<template>
  <div
    ref="content">
    <slot />
  </div>
</template>

<script>
import { propsPopup } from './shared/props.js'

export const opts = propsPopup
</script>

<script setup>
import { inject, ref, onMounted, onBeforeUnmount } from 'vue'
import { watchInstance } from './shared/watch.js'
import { setOptions } from './shared/options.js'
import { defineHandlers, removeHandlers } from '@/shared/events.js'
import { eventsPopup } from './shared/events.js'
import { Popup } from 'maplibre-gl'

// inject and dom check
const map = inject('map')
const marker = inject('marker')

// props
const props = defineProps(opts)

// base options
const options = setOptions(props)
delete options.lngLat

// data
const content = ref(null)
const popup = ref(new Popup(options))

// events
const handlers = defineHandlers(eventsPopup, popup)

onMounted(() => {
  popup.value.setDOMContent(content.value)
  if (marker) marker.value.setPopup(popup.value)
  else if (props.lngLat) popup.value.setLngLat(props.lngLat).addTo(map.value)

  // watch
  watchInstance(popup, props)
})

// clean
onBeforeUnmount(() => {
  removeHandlers(handlers, popup)
  if (marker) marker.value.setPopup()
  popup.value.remove()
})

// expose to parent
defineExpose({ popup })
</script>
